summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Henkjan Gersen <h.gersen@gmail.com>2015-05-04 19:10:17 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2015-05-04 19:10:17 +0700
commit68dbd6d1272b0ab71dd31a3c6e7591be40c005f0 (patch)
treeea0ea97cb9ace24f72a97ea199d785d5cd7546ba
parent74ec17330881c13a5114d9399f14b6247b10634e (diff)
downloadslackbuilds-68dbd6d1272b0ab71dd31a3c6e7591be40c005f0.tar.gz
slackbuilds-68dbd6d1272b0ab71dd31a3c6e7591be40c005f0.tar.xz
network/kwakd: Added (web server).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--network/kwakd/README13
-rw-r--r--network/kwakd/doinst.sh25
-rw-r--r--network/kwakd/kwakd.SlackBuild103
-rw-r--r--network/kwakd/kwakd.info10
-rw-r--r--network/kwakd/kwakd.port.patch11
-rw-r--r--network/kwakd/slack-desc18
6 files changed, 180 insertions, 0 deletions
diff --git a/network/kwakd/README b/network/kwakd/README
new file mode 100644
index 0000000000..490ea3ddc6
--- /dev/null
+++ b/network/kwakd/README
@@ -0,0 +1,13 @@
+Kwakd is a very small foot print web server written in C
+that serves blank html pages for any request. The request
+can be arbitrary, may even be invalid, but only its first
+line will be read and the response will be the same: a blank
+page consisting of "<html> </html>". It is quite easy to
+change the response to whatever you like though. Kwakd can
+be handy if you want to intercept traffic from your client
+(web browser for example) to annoying sites and direct all
+such traffic to your local machine.
+
+By default kwakd uses port 8000, but this can be changed in
+the provided initscript by changing the port option.
+See /etc/rd.c/rc.kwakd
diff --git a/network/kwakd/doinst.sh b/network/kwakd/doinst.sh
new file mode 100644
index 0000000000..c84bbbb6a2
--- /dev/null
+++ b/network/kwakd/doinst.sh
@@ -0,0 +1,25 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.kwakd.new
diff --git a/network/kwakd/kwakd.SlackBuild b/network/kwakd/kwakd.SlackBuild
new file mode 100644
index 0000000000..c9d93bb7df
--- /dev/null
+++ b/network/kwakd/kwakd.SlackBuild
@@ -0,0 +1,103 @@
+#!/bin/sh
+
+# Slackware build script for kwakd
+
+# Copyright 2015, Henkjan Gersen, Bristol, UK
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=kwakd
+VERSION=${VERSION:-0.5}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e # Exit on most errors
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# the provided kwakd.init script uses port 80 by default, which fails silently when apache is running.
+# hence patch the script to use the default port 8000 instead which is consistent with the manpages
+cat $CWD/kwakd.port.patch | patch -p0 || exit
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --mandir=/usr/man \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+# move provided init script to slackware location; and make it executable by default
+install -D -m 0755 $PRGNAM.init $PKG/etc/rc.d/rc.$PRGNAM.new
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/network/kwakd/kwakd.info b/network/kwakd/kwakd.info
new file mode 100644
index 0000000000..a4a646f2c2
--- /dev/null
+++ b/network/kwakd/kwakd.info
@@ -0,0 +1,10 @@
+PRGNAM="kwakd"
+VERSION="0.5"
+HOMEPAGE="https://code.google.com/p/kwakd/"
+DOWNLOAD="https://kwakd.googlecode.com/files/kwakd-0.5.tar.gz"
+MD5SUM="96b77ad9e9e7ce2c10fe03a6568f2156"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Henkjan Gersen"
+EMAIL="h.gersen@gmail.com"
diff --git a/network/kwakd/kwakd.port.patch b/network/kwakd/kwakd.port.patch
new file mode 100644
index 0000000000..ef2bbf7b03
--- /dev/null
+++ b/network/kwakd/kwakd.port.patch
@@ -0,0 +1,11 @@
+--- kwakd.init.orig 2015-05-02 09:20:14.430024081 +0100
++++ kwakd.init 2015-05-02 09:20:28.921897077 +0100
+@@ -15,7 +15,7 @@
+
+ start() {
+ echo -n $"Starting $prog: "
+- daemon $prog -b -p 80
++ daemon $prog -b -p 8000
+ RETVAL=$?
+ echo
+ [ $RETVAL -eq 0 ] && touch $lockfile
diff --git a/network/kwakd/slack-desc b/network/kwakd/slack-desc
new file mode 100644
index 0000000000..3aa51f426e
--- /dev/null
+++ b/network/kwakd/slack-desc
@@ -0,0 +1,18 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+kwakd: kwakd (web server)
+kwakd:
+kwakd: Kwakd is a very small foot print web server written in C that serves
+kwakd: blank html pages for any request. The request can be arbitrary, may
+kwakd: even be invalid, but only its first line will be read and the
+kwakd: response will be the same: blank page consisting of "<html> </html>".
+kwakd: It is quite easy to change the response to whatever you like though.
+kwakd: Kwakd can be handy if you want to intercept traffic from your client
+kwakd: (web browser for example) to annoying sites and direct all
+kwakd: such traffic to your local machine.